/*
 * debtags - Implement package tags support for Debian
 *
 * Copyright (C) 2003--2006  Enrico Zini <enrico@debian.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef EPT_H
#define EPT_H

#include <ept/init.h>
#include <ept/forward.h>
#include <ept/configuration/apt.h>
//#include <ept/cache/cache.h>
#include <ept/cache/debtags/serializer.h>
#include <ept/cache/debtags/vocabulary.h>
#include <ept/cache/debtags/tagmap.h>
#include <ept/cache/debtags/update.h>
#include <ept/cache/tag.h>
#include <ept/cache/package.h>
#include <ept/cache/version.h>
#include <ept/cache/apt/packages.h>
//#include <ept/predicate/factory.h>
//#include <ept/predicate/predicate.h>

using namespace ept::configuration;
using namespace tagcoll;

typedef apt::cache::Aggregator Aggregator;
typedef apt::cache::Package Package;
typedef apt::cache::Tag Tag;
typedef apt::cache::Facet Facet;
typedef apt::cache::Packages Packages;
typedef apt::cache::Version Version;
typedef apt::cache::Vocabulary Vocabulary;
typedef apt::cache::TagMap TagMap;
typedef apt::cache::Index Index;


class Ept
{
	struct antani {
		antani()
		{
			ept::init();
		}
	} call_ept_init;

	Aggregator agg;

public:
	Ept(bool editable = false) {}

	Aggregator& aggregator() { return agg; }
	Index& packages() { return agg.index(); }
	TagMap& tagmap() { return agg.tagMap(); }
	Vocabulary& vocabulary() { return agg.vocabulary(); }

	template<typename OUT>
	void readCollection(const string& file, const OUT& out);

	template<typename OUT>
	void readCollectionRaw(const string& file, const OUT& out);
};

#endif
// vim:set ts=4 sw=4:
